/*
BYOND is capable of almost anything, don't think you're limited in any way or you will be.
Pretty much everything outside of full 3d graphics is easily acomplishablable with BYOND;
Its all a matter of how best to go about it

Some Tips for Beginers

Programming Tips:
	NEVER Repeat any coding, if you ever have to use the exact same coding twice:
	Make it into a proc! this will save time and effort, plus if you ever want to go back
	and edit what was in that code, youll only have to change it once
	Don't number variables (Pet1, Pet2, Pet3), simply use a list (Pets)

Compiling Your Project:
	How to Compile:
		Select Build on the top menu bar of Dream Maker, then select Compile
	Compile Often! After youve comleted a few lines of coding, or a general area of it, compile
	Theres nothing worse then completing 5 different systems and then compiling to get 50 Errors
	Compling your game will also automaticaly save any files that may have been updated
	When you compile the source, it will tell you any mistakes you have made in your coding
	The errors will report at the bottom of Dream Maker, double click to jump to them in the code

Variables:
	Variable names can be anything you want, as long as that name isnt already in use
	however its best to name a variable something that will be easy to remember
	you could name the variable for Gold var/Penquins, but that isnt exactly the best description of its use

	Though variable names dont have any standards Gold gold GoLd gOld, theyd all work the same
	i prefer, and recomend, using camel casing, capitalizing the first letter of each word
	this helps greatly in readability, especialy with multi word variables like trymediasystems/TryMediaSystems

Design Variabls:
	density: setting density to 1 makes it so you cant walk on something, 0 allows you to pass over it
	opacity: setting opacity to 1 makes it so you cant see past something, 0 gives it a normal appearance
	layer: using layer you can make certain objects appear over others

The Map:
	the map included in these demos are very small
	to increase it size, open the map by double clicking map.dmp in the left bar under the File tab
	then on the top menu bar of dream maker, select Options and Set Map Size
	from there you can easily increase the size of your map (I recomend using 200x200 maps)

Comments:
	is the gray text everywhere getting on your nerves and just distracting you from the actual coding?
	go to Options on the top menu bar of dream maker and select coding preferences
	From there you can change the Comment font color to white, which will hide it against the background

	Comments are lines in your coding that will not effect the actual coding
	a single line comment can be placed by using //comment here
	a multi lined comment can be placed by using /*comment here*/ (as you can see in this file)
	you could also use a slash(\) in order to make a single comment run for two, or more lines, however that is
	rarely needed.

Dream Maker Help:
	The dream maker help files are there for a reason, if theres something in this demo you dont understand
	or just something youd like to know more about, dont be afraid to check them out(thats how i learned)
	Want to know more about the input proc for example?
	Select Help from the top menu bar on dream maker, then select Help On...
	from here use the topic or search tab to quickly find what youre looking for
	if youre looking for a specific proc the topic tab is the best choice
	but if youre just looking for a general concept, like how to play music or sound effects
	try typing music in the search tab and see what comes up
	Be as vague as possible when searching, dont put in "How to play music in a byond game"
	simply put in music to get the best results, sure it might be a little more to sort through
	but youll have a much better chance of finding what youre looking for

Tabbing:
	ever code a bunch of lines and then have the problem of inconsistent indentation?
	selecting multiple lines at once and pressing tab will tab them all in at the same time
	selecting them and holding shift then pressing tab will remove tabing, moving them all to the left

Fixing Errors:
	There are 3 main Types of Errors:
		Compile Errors: Found when compiling the source files, usualy somewhat easy to fix
		Runtime Errors: Found when something goes wrong with the coding, somewhat more difficult to fix
		Bugs: Bugs are unexpected results from the coding, these range in difficulty to fix depending on the circumstances

	By double clicking on a compile error it will take you to the line in the coding where it occured

	by using the "#define DEBUG" line your runtime errors will report both line number and file location
	though this isnt as simple as just double clicking an error, it makes it alot easier to find and fix runtimes
	Selecting Edit from the top menu bar on dream maker, and then selecting Go To... you can input a line number to jump to)
	The #define DEBUG line is included in Main.dmi of this project, and allows reporting even when hosting
	An alternate method is to goto Build > Prefrences for GameName, and check Generate Debug Info
	Howerever! this alternate method will only report the errors when ran from the source files, not from the host files

Common Compile Errors:
	Inconsistent Indenation: means one or more lines it tabbed in too far or not far enough
	Undefined Variable: Means youre trying to use a variable that doesnt exist! Try defining it: var/VariableName

Common Runtime Errors:
	cannot read null.variable: when trying to set atom.var it means that atom is non existant
	Undefined Variable: when trying to set atom.var it means that the atom doesnt have the variable
	Type Mismatch: means youre trying to add 2 different variables ie: "pie"+2, text and numbers dont mix
*/