proc	//define global procedures
	FormatText(var/ToFormat)	//define the global procedure FormatText, and have the arguement passed saved to the new variable "ToFormat"
		if(!(length(ToFormat)))	// use the built in "length()" proc to determine if "ToFormat" has any length to it. This would perferably
								//be handled in a seperate proc, but this is a quick demo
			return "NoFormat"	//if "ToFormat" has no length, return the value - "NoFormat" -, this will also end the proc
		var/tmp/LenLen = length(ToFormat)	//Define a temporary variable and set it to the length of "ToFormat" since we already know
											//"ToFormat"'s length is not 0, we no longer have to do anything with this yet
		var/tmp/IsPeriod = copytext("[ToFormat]",(LenLen - 5))	//Create another temporary variable, we will use this to determine if there is
																//a period at the end of this message. use the "copytext(Text2Copy,Pos2Start)"
																//built in procedure. define "ToFormat" as the text to copy, and the length(set
																//to LenLen via the last part of the FormatText proc) minus 5. This means it will
																//only copy the last 5 letters/numbers/punctuation of the string.
		if(!findtext("[IsPeriod]",".") && !findtext("[IsPeriod]","!") && !findtext("[IsPeriod]","?"))	//use the built in
																						//"findtext(Text2Check,Text2CheckFor) proc checking
																						//"IsPeriod"(which was defined in the last part of the
																						//"FormatText" proc) and checking for a period, then
																						//and exclamation point, then for a question mark.
			ToFormat += "."		//If none are found then add a period to the end of the "ToFormat" String
		return ToFormat		//Return the "ToFormat" String