/*
In this demo we used
	Mobs:
		These are "mobile objects" derived from /mob. Human players are associated with a mob when they log on.

	Local Variables:
			Variables attached to a mob. These can be accessed by calling the mob's variable via src(Source), usr(User),
		or a pre-defined variable that was set to the mob's variable your accessing(See local variables example 1 - LV1).
		These types of variables can be used to keep track of virtually anything, such as a mob's Level(See LV2), a mob's
		e-mail address(See LV3), or even a list of a mob's houses(See LV4).

	Global Variables:
			These are world variables. These can be accessed by calling "global." then the variables name, however these only
		need to be defined as the variable name under the world's variables(See global variables example 1 - GV1). This type
		of variable can be used in world procs, mob procs, mob verbs, or in practically anything you might need to access
		it for.

	Verbs:
			Verbs are exactly what they sound like, actions that can be called like commands. These can be attached to mobs
		(See Verbs example 1 - V1), objs(See V2), turfs(See V3), and areas(See V4). You can use these depending if you have access to the verb's
		source(See V5).

	Local Procedures:
		-Proc stands for Procedure.
			-Local Procs are derived from mobs. These are revolve around the source mob. They can be used to generate a who list displaying
		who is currently online in that world(See local procedure example 1 - LP1), or to check if a mob is dead in a game(See LP2). They
		can even be used to show an in game attack's damage on screen(See LP3). In short, and in my opinion, i see these as verbs that a
		mob can't call on command while having access to the source.

	Global Procedures:
			Global Procedures are procs that are used by the world, or anything in it. They can be used to generate a number in a certain
		format(See global procedure example 1), to respawn everything in the world that has been deleted during runtime on a delay(See GP2),
		or even used to check if something is in a list(See GP3). These virtually double as global verbs.
*/