/*
	In this demo we used:
		Mobs:
			Covered in the last demo

		Turfs:
				Turfs cover the surface of the map. They are derived from /turf. These are used to create things like
			grass, buldings, trees, etc(See turf example 1 - T1). We use effect variables to give the turfs more depth.

		Effect Variables:
				Effect variables can be used on mobs, objects, or turfs(See effect variable example 1 - EV1). Virtually anything with
			a physical attribute on a map. They can provide effects such as Density(See EV2), or the layer of an object, mob, or turf(See EV3).
			There are other Effect variables but we wont be getting into that yet, if at all.

		Built in Loc(Location) var:
				The built in Loc variable is the basis of a mob's location on a map. By changing this variable you will change there
			view, and physical location on any map(See location example 1 - L1).

		Built in procs of Login and Logout:
				The built in Login and Logout procs are called when somone connects, or disconnects from the world. This proc can be used to alter
			the built in procedure, or even to add things into it. This can varry from a relog timer(See Login and Logout Example 1 - L&L1),
			displaying a message when someone logs in or out(See L&L2), or even checking if someone is in a pre-defined ban list(See L&L3).

		A Map File:
				A map is exactly what it sounds like, a map. Its the predetermined world layout inside the game. You create one of these by going to
			File - New - Map File. However, you will need to define turfs before you can use them.

		Icons:
				Icons are what will physically show a mob, object, or turf. These are made nearly the same way, File - New - Icon File. After you
			create an icon file the default size is 32x32, of which you can then create icon states in. Look for a Icon file(.dmi) for further
			understanding.

		step_size:
				step_size is a built in variable that controls how many pixels a mob with move everytime it steps. In the default project's case,
			8. One tile in a default project is equal to 32 by 32 pixels, so youd have to step and estimated four times to move one tile.
*/