/*
	In this demo, the new things we have used are:
		Mob Types:
				In this demo we have introduced mob types. Mob types are derived from the same path as mob procs(/mob). Mob types can be altered
			to however you see fit. You can use different mob types for different races(See mob type examples 1 - MT1), or for hostile, allied,
			firendly, and civilian mobs(See MT2). You could even define different races as mob types under hostile and friendly mob types(See MT3).
			The options with mob types are almost endless, let your mind wander and create whatever you see fit with this.

		Proc Overwrites:
				Proc overwrites are constructed when you give a group of mob types a procedure, then under a more detailed version of that mob type
			you alter the procedure. With this you could define a mob type such as enemies(see proc overwrite example 1 - PO1), and give all enemies
			proc called target()(See PO1B). The target proc will defaultly work as a system that will target any mob near it as long as it is not an
			enemy mob. With this you can define a mob type under enemies called Evil(See PO1C). Under the Evil mob type you can access the target()
			procedure. You can then rewrite it to target any mob even if it is an enemy(See PO1D).


		Objects:
				Objects are derived from /obj. Objects can be used to create various things throughout the world your creating. Objects can be used
			to generate overlays(See object example 1 - O1). They can be used to create objects that move as you bump into them(See 02). They can
			even be used to create objects that will effect the mobs around them, like healing water(see O3).


		Overlays:
				Overlays are images that are added on top of a mob's image. They can be used to add things like clothes, hair, or effects like
			an aura on a mob.


		Built in pick() Procedure:
				pick() is a built in procedure that runs in the following format - pick(ThingsToPickFrom1,ThingsToPickFrom2,ThingsToPickFrom3,Etc).
			pick() can be used for various things such as selecting a random color, team, or hairstyle(see pick() example 1 - P()1). You could even
			use this method to randomly pick a direction for a mob to move in during an ai() loop(See P()2)



		Built in get_dist() Procedure -
				get_dist() is a built in procedure that runs in the following format - get_dist(Spot1, Spot2). In this format Spot1/Spot2 can be
			either a mob, an object, or a turf. This procedure will compare the distance in 32x32 tiles between Spot1 and Spot2. This is useful
			for things like finding out if a mob is within striking range(See get_dist() example 1 - G_D()1), or if your nearing a hostile
			zone(See G_D()2).


		Built in step() Procedure -
				step() is a built in procedure that runs in the following format step(Source, Direction). In this format Source is the mob that
			will be movine, and Direction is the direction to move in, for example NORTH, or SOUTH. This is useful for things like steping randomly
			in a case you wouldnt want to use step_rand in, or to step randomly in a set number of directions. This can also be used to create custom
			movement procedures.


		Built in step_to() Procedure -
				step_to() is a built in procedure that runs in the following format step_to(Source, WhatToStepTo). In this format Source is a mob
			that will be moving, just like the step() procedure. WhatToStepTo can be a mob, object, turf, or area. This is useful for AI interaction,
			such as a mob chasing you or finding its way back to a certain spot after a certain time. It can also be used to have a player forced to
			move towards an object that you want them to interact with.


		Built in oview() Procedure -
				oview() is a built in procedure that runs in the following format oview(TilesOutward, Source). In this format TilesOutward is a
			number defining how many tiles outward from the soruce that we will be searching in. Source is the mob, turf, object, or area whos
			oview we will be searching in. This can be useful for finding a target for an enemy AI, or finding how many people are in an area. It
			could also be used to make a basic say verb only sending the output to those on the screen of a players map.


		Built in spawn() Procedure -
				spawn() is a built in procedure that runs in the following format spawn(SpawnInTicks). In this format SpawnInTicks is a
			number defining how many ticks will go by before what has been derived from the spawn() procedure will happen. This is useful for
			asigning random definintions to a mob such as its respawn area in its New() procedure during runtime.


		Built in sleep() Procedure -
				sleep() is a built in procedure that runs in the following format sleep(TicksToSleep). In this format TicksToSleep is a
			number defining how many ticks the entire procedure will pause for. This is useful for a number of things, such as adding timed
			delays to a targeting procedure, or adding a set delay to move depending on a player's speed variable.


		Built in pixel_x Procedure -


		Built in pixel_y Procedure -


		Built in mouse_opacity Procedure -

*/